import React from 'react';
import { ButtonProps } from '@material/react-button';
declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
declare type ButtonTypes = HTMLAnchorElement | HTMLButtonElement;
export interface DialogButtonProps<T extends ButtonTypes> extends Omit<ButtonProps<T>, 'initRipple'> {
    action: string;
    className?: string;
    isDefault?: boolean;
}
declare const DialogButton: <T extends ButtonTypes>(props: DialogButtonProps<T>) => React.ReactElement<any>;
declare type DialogButton<T extends ButtonTypes> = React.ReactElement<DialogButtonProps<T>>;
export default DialogButton;
