import React from 'react';
import { MDCFloatingLabelFoundation } from '@material/floating-label/foundation';
import { MDCFloatingLabelAdapter } from '@material/floating-label/adapter';
export interface FloatingLabelProps extends React.LabelHTMLAttributes<HTMLLabelElement> {
    className?: string;
    handleWidthChange?: (width: number) => void;
    float?: boolean;
}
interface FloatingLabelState {
    classList: Set<string>;
}
export default class FloatingLabel extends React.Component<FloatingLabelProps, FloatingLabelState> {
    foundation: MDCFloatingLabelFoundation;
    labelElement: React.RefObject<HTMLLabelElement>;
    static defaultProps: Partial<FloatingLabelProps>;
    state: FloatingLabelState;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: FloatingLabelProps): void;
    initializeFoundation: () => void;
    readonly classes: string;
    readonly adapter: MDCFloatingLabelAdapter;
    shake: () => void;
    removeClassFromClassList: (className: string) => void;
    handleWidthChange: () => void;
    onShakeEnd: () => void;
    render(): JSX.Element;
}
export {};
