import React from 'react';
import { MDCLineRippleFoundation } from '@material/line-ripple/foundation';
import { MDCLineRippleAdapter } from '@material/line-ripple/adapter';
export interface LineRippleProps extends React.HTMLProps<HTMLDivElement> {
    className?: string;
    active?: boolean;
    rippleCenter?: number;
}
interface LineRippleState {
    classList: Set<string>;
    style: React.CSSProperties;
}
export default class LineRipple extends React.Component<LineRippleProps, LineRippleState> {
    static defaultProps: {
        className: string;
        style: {};
        active: boolean;
        rippleCenter: number;
    };
    foundation_: MDCLineRippleFoundation;
    state: LineRippleState;
    componentDidMount(): void;
    componentDidUpdate(prevProps: LineRippleProps): void;
    componentWillUnmount(): void;
    readonly adapter: MDCLineRippleAdapter;
    readonly classes: string;
    setStyle: (varName: string, value: string) => void;
    getMergedStyles: () => React.CSSProperties;
    onTransitionEnd: (evt: React.TransitionEvent<Element>) => void;
    render(): JSX.Element;
}
export {};
