import React from 'react';
import { MDCNotchedOutlineFoundation } from '@material/notched-outline/foundation';
import { MDCNotchedOutlineAdapter } from '@material/notched-outline/adapter';
export interface NotchedOutlineProps extends React.HTMLProps<HTMLDivElement> {
    className?: string;
    notchWidth?: number;
    notch?: boolean;
}
interface NotchedOutlineState {
    classList: Set<string>;
    foundationNotchWidth?: number;
}
export default class NotchedOutline extends React.Component<NotchedOutlineProps, NotchedOutlineState> {
    foundation?: MDCNotchedOutlineFoundation;
    notchedEl: React.RefObject<HTMLDivElement>;
    static defaultProps: Partial<NotchedOutlineProps>;
    state: NotchedOutlineState;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: NotchedOutlineProps): void;
    readonly classes: string;
    readonly label: HTMLElement | null;
    readonly adapter: MDCNotchedOutlineAdapter;
    addClass: (className: string) => void;
    notch: () => void;
    render(): JSX.Element;
}
export {};
