import React from 'react';
import { MDCSwitchAdapter } from '@material/switch/adapter';
import { MDCSwitchFoundation } from '@material/switch/foundation';
export interface SwitchProps extends React.HTMLProps<HTMLInputElement> {
    checked?: boolean;
    className?: string;
    disabled?: boolean;
    nativeControlId?: string;
}
interface SwitchState {
    nativeControlChecked: boolean;
    checked: boolean;
    classList: Set<string>;
    disabled: boolean;
    nativeControlDisabled: boolean;
}
export default class Switch extends React.Component<SwitchProps, SwitchState> {
    rippleActivator: React.RefObject<HTMLInputElement>;
    foundation: MDCSwitchFoundation;
    constructor(props: SwitchProps);
    static defaultProps: Partial<SwitchProps>;
    componentDidMount(): void;
    componentDidUpdate(prevProps: SwitchProps): void;
    componentWillUnmount(): void;
    readonly classes: string;
    readonly adapter: MDCSwitchAdapter;
    onChange: (evt: React.ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export {};
